

#------------------------------------------------------------------------------
# THIS CODE AND ANY ASSOCIATED INFORMATION ARE PROVIDED AS IS WITHOUT
# WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
# LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS
# FOR A PARTICULAR PURPOSE. THE ENTIRE RISK OF USE, INABILITY TO USE, OR 
# RESULTS FROM THE USE OF THIS CODE REMAINS WITH THE USER.
#
# AUTHOR(s):
#     Eyal Doron ()
#------------------------------------------------------------------------------
# Hope that you enjoy it ! 
# And May the force of PowerShell will be with you   :-)
#12-2014    
# Version 1.0
#------------------------------------------------------------------------------



Function Disconnect-ExchangeOnline {Get-PSSession | Where-Object {$_.ConfigurationName -eq "Microsoft.Exchange"} | Remove-PSSession}
Function Validate-UserSelection
{
    Param(
        $AllowedAnswers,
        $ErrorMessage,
        $Selection
    )
    foreach($str in $AllowedAnswers.ToString().Split(","))
    {
        if($str -eq $Selection)
        {
            return $true
        }
    }
    Write-Host $ErrorMessage -ForegroundColor Red -BackgroundColor Black
    return $false

}


Function Set-AlternatingRows {
       <#
       
       #>
    [CmdletBinding()]
       Param(
             [Parameter(Mandatory=$True,ValueFromPipeline=$True)]
        [string]$Line,
       
           [Parameter(Mandatory=$True)]
             [string]$CSSEvenClass,
       
        [Parameter(Mandatory=$True)]
           [string]$CSSOddClass
       )
       Begin {
             $ClassName = $CSSEvenClass
       }
       Process {
             If ($Line.Contains("<tr>"))
             {      $Line = $Line.Replace("<tr>","<tr class=""$ClassName"">")
                    If ($ClassName -eq $CSSEvenClass)
                    {      $ClassName = $CSSOddClass
                    }
                    Else
                    {      $ClassName = $CSSEvenClass
                    }
             }
             Return $Line
       }
}



Function Write-White($Message)
{
    Write-Host  $Message -ForegroundColor White 
}


$FormatEnumerationLimit = -1
$ExportInfo = "The information was exported to the following location C:\INFO"
$settings_array1 = "Received", "SenderAddress","RecipientAddress","Subject","Status", @{Name="size in KB";Expression={Format-BytesInKiloBytes -bytes $_.Size}},"MessageId","FromIP","ToIP"  
$settings_array3 = "Received", "SenderAddress","RecipientAddress","Subject","Status", @{Name="size in KB";Expression={$_.size / 1Kb}},"MessageId", "StartDate","EndDate","FromIP","ToIP" 
$Aarray4 = "DisplayName" , @{Name='Licenses';Expression={$_.Licenses -join ';'}}

$Date = Get-Date

#------------------------------------------------------------------------------
# PowerShell console window Style
#------------------------------------------------------------------------------

$pshost = get-host
$pswindow = $pshost.ui.rawui

	$newsize = $pswindow.buffersize
	
	if($newsize.height){
		$newsize.height = 3000
		$newsize.width = 150
		$pswindow.buffersize = $newsize
	}

	$newsize = $pswindow.windowsize
	if($newsize.height){
		$newsize.height = 50
		$newsize.width = 150
		$pswindow.windowsize = $newsize
	}

#------------------------------------------------------------------------------
# HTML Style start 
#------------------------------------------------------------------------------
$Header = @"
<style>
Body{font-family:segoe ui,arial;color:black; }
H1{ color: white; background-color:#1F4E79; font-weight:bold;width: 70%;margin-top:35px;margin-bottom:25px;font-size: 22px;padding:5px 15px 5px 10px; }
H2{ color: white; background-color:#385643; font-weight:bold;width: 70%;margin-top:35px;margin-bottom:25px;font-size: 22px;padding:5px 15px 5px 10px; }
TABLE {border-width: 1px;border-style: solid;border-color: black;border-collapse: collapse;}
TH {border-width: 1px;padding: 5px;border-style: solid;border-color: #d1d3d4;background-color:#0072c6 ;color:white;}
TD {border-width: 1px;padding: 3px;border-style: solid;border-color: black;}
.odd  { background-color:#ffffff; }
.even { background-color:#dddddd; }
</style>

"@
#------------------------------------------------------------------------------
# HTML Style END
#------------------------------------------------------------------------------

#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# Export information: Exchange Online + Office 365 ( AD Azure) objects PowerShell Script menu  
#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

$Loop = $true
While ($Loop)
{
    write-host 
    write-host +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    write-host   "Manage Exchange URL address -  PowerShell Script menu"
    write-host +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    write-host
    
    write-host -ForegroundColor white  'A: Get information about Exchange web service URLs and Outlook AnyWhere configuration settings ' -BackgroundColor Blue 
  
    write-host
    write-host  ' 1)  View information about ALL Existing Exchange servers URL address '
    write-host  
    write-host  ' 2)  View information about specific Exchange server URL address '
    write-host
	
    write-host -ForegroundColor white  'B: Manage Exchange servers URL address          '  -BackgroundColor Blue
    write-host	
    write-host 	'3)  Set the URL address of Exchange web services  '
    write-host
	write-host 
    write-host -ForegroundColor white  'C: Manage Exchange servers Autodiscover SCP URL address '   -BackgroundColor Blue
    
    write-host 
    write-host '4)  Set the value of the change servers Autodiscover SCP URL address '
    write-host 
	
	
    write-host -ForegroundColor white  'D: Manage Outlook Anywhere settings    '  -BackgroundColor Blue 
    
    write-host
    write-host 													'5)  View Outlook Anywhere setting '
    write-host 
	
    write-host -ForegroundColor white -BackgroundColor DarkGreen    'Outlook Anywhere - Exchange 2007\2010 CAS server Infrastructure    ' 
    write-host 
	write-host 													'6)  Enable Outlook Anywhere on Exchange 2007\2010 CAS server '
	write-host 	
	write-host 													'7)  Set (configure) Outlook Anywhere authentication settings on Exchange 2007\2010 CAS server  '
    write-host
	
    write-host -ForegroundColor white -BackgroundColor DarkGreen 'Outlook Anywhere - Exchange 2013 CAS server Infrastructure    ' 
  
	write-host
	write-host 													'8)  Set (configure) Outlook Anywhere settings on Exchange 2013 CAS server '
    write-host
    write-host
	write-host ---------------------------------------------------------------------------------------------------- -ForegroundColor Yellow
	write-host -ForegroundColor Red            "9)  Disconnect PowerShell session" 
    write-host
    write-host -ForegroundColor Red            "10)  Exit" 
    write-host

    $opt = Read-Host "Select an option [0-10]"
    write-host $opt
    switch ($opt) 


{


		
		#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
		#A: Get information about Exchange web service URLs and Outlook Anywhere configuration 
		#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


		1{


		####################################################################################################
		# Display information + Export all of the available Exchange CAS servers in the organization
		######################################################################################################


		# Section 1: information 

						clear-host

						write-host
						write-host
						write-host  -ForegroundColor Magenta	ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                             
						write-host  -ForegroundColor white		Introduction                                                                                          
						write-host  -ForegroundColor white		---------------------------------------------------------------------------------------------------------                                                              
						write-host  -ForegroundColor white  	'This option will Display information about: different Exchange services of   '
						write-host  -ForegroundColor white  	'all of the available Exchange CAS servers in the organization  '
						write-host  -ForegroundColor white  	'The information includes: the URL address of the internal and external Exchange CAS services  '
						write-host  -ForegroundColor white  	'The information will be displayed on the screen and, at the same time will be exported to a sub folder folder    '
						write-host  -ForegroundColor white  	'named:Exchange URL address and Outlook AnyWhere information the will be stored at C:INFO    '
						write-host  -ForegroundColor Magenta	ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                       
						write-host

		#  Section 1#7 |  Start Exchange Web services information
		
		write-host
		write-host ***************************************************************** -ForegroundColor white
		write-host "Information about Exchange Web services URL address"             -ForegroundColor white  -BackgroundColor DarkGreen    
		write-host ***************************************************************** -ForegroundColor white
		write-host "Information about Exchange Web services virtual directory URL Address" -ForegroundColor Yellow
		Get-WebServicesVirtualDirectory | FL identity,internalurl,externalurl | Out-String

		$EWSDir = Get-WebServicesVirtualDirectory
		 if ($EWSDir.ExternalUrl -eq $null -or $EWSDir.ExternalUrl -eq "")
		{
			write-host "Warning the Exchange Web services URL Value is empty!" -ForegroundColor Red
		}
		else
		{
			
		}
		write-host ------------------------------------------------------------------------------------ -ForegroundColor white
		write-host
		write-host
		#  Section 1#7 |  End Exchange Web services information


		#  Section 2#7 |  Start OWA services information
		
		write-host
		write-host ***************************************************************** -ForegroundColor white
		write-host "Information about Exchange OWA URL address"                      -ForegroundColor white  -BackgroundColor DarkGreen    
		write-host ***************************************************************** -ForegroundColor white

		
		write-host "Information about OWA virtual directory URL Address" -ForegroundColor Yellow
		Get-OwaVirtualDirectory | FL identity,internalurl,externalurl | Out-String

		$OWADir = Get-OwaVirtualDirectory
		 if ($OWADir.ExternalUrl -eq $null -or $OWADir.ExternalUrl -eq "")
		{
			write-host "Warning the OWA URL Value is empty!" -ForegroundColor Red
		}
		else
		{
			
		}
		write-host ------------------------------------------------------------------------------------ -ForegroundColor white
		write-host
		write-host
        #  Section 2#7 |  End OWA services information
		
		
		#  Section 3#7 |  Start ECP services information
		write-host
		write-host ***************************************************************** -ForegroundColor white
		write-host "Information about Exchange ECP URL address"                      -ForegroundColor white  -BackgroundColor DarkGreen    
		write-host ***************************************************************** -ForegroundColor white

		write-host "Information about ECP virtual directory URL Address" -ForegroundColor Yellow
		Get-EcpVirtualDirectory | FL identity,internalurl,externalurl | Out-String

		$ECPDir = Get-EcpVirtualDirectory
		 if ($ECPDir.ExternalUrl -eq $null -or $ECPDir.ExternalUrl -eq "")
		{
			write-host "Warning the ECP URL Value is empty!" -ForegroundColor Red
			write-host "If the server is Exchange CAS 2007 this error is expected" -ForegroundColor Red
		}
		else
		{
			
		}
		write-host ------------------------------------------------------------------------------------ -ForegroundColor white
		write-host
		write-host
		#  Section 3#7 |  End ECP services information
		
			
		#  Section 4#7 |  Start Autodiscover Active Directory SCP services information
		
		write-host
		write-host *****************************************************************       -ForegroundColor white
		write-host "Information about Exchange Internal Autodiscover infrastructure "      -ForegroundColor white  -BackgroundColor DarkGreen 
        write-host "(AutodiscoverServiceInternalUri) "                                     -ForegroundColor white  -BackgroundColor DarkGreen    		
		write-host *****************************************************************       -ForegroundColor white

	


		write-host "Information about Autodiscover URL Address" -ForegroundColor Yellow
		Get-ClientAccessServer | FL identity,AutodiscoverServiceInternalUri | Out-String

		$AUTODISDir = Get-ClientAccessServer
		 if ($AUTODISDir.AutodiscoverServiceInternalUri -eq $null)
		{
			write-host "Warning the Exchange Autodiscover URL Value is empty!" -ForegroundColor Red
		}
		else
		{
			
		}
		write-host ------------------------------------------------------------------------------------ -ForegroundColor white
		write-host
		write-host
		#  Section 4#7 |  End Autodiscover Active Directory SCP services information
		
		
        #  Section 5#7 |  Start ActiveSync services information
		
		
		write-host
		write-host ***************************************************************** -ForegroundColor white
		write-host "Information about Exchange ActiveSync URL address"               -ForegroundColor white  -BackgroundColor DarkGreen    
		write-host ***************************************************************** -ForegroundColor white

			
		write-host "Information about ActiveSync virtual directory URL Address" -ForegroundColor Yellow
		Get-ActiveSyncVirtualDirectory  | FL identity,internalurl,externalurl | Out-String

		$EASDir = Get-ActiveSyncVirtualDirectory 
		 if ($EASDir.ExternalUrl -eq $null -or $EASDir.ExternalUrl -eq "")
		{
			write-host "Warning the ActiveSync URL Value is empty!" -ForegroundColor Red
			write-host "In some scenarios the external URL address should set to NULL" -ForegroundColor Red
		}
		else
		{
			
		}
		write-host ------------------------------------------------------------------------------------ -ForegroundColor white
		write-host
		write-host
		write-host
		#  Section 5#7|  End ActiveSync services information

		
		
		#  Section 6#7 |  Start OAB services information
		
		
		
		write-host
		write-host ***************************************************************** -ForegroundColor white
		write-host "Information about Exchange OAB  URL address"                     -ForegroundColor white  -BackgroundColor DarkGreen    
		write-host ***************************************************************** -ForegroundColor white
		
		write-host "Information about OAB virtual directory URL Address" -ForegroundColor Yellow
		Get-OABVirtualDirectory  | FL identity,internalurl,externalurl | Out-String

		$OABDir = Get-OABVirtualDirectory
		 if ($OABDir.ExternalUrl -eq $null -or $OABDir.ExternalUrl -eq "")
		{
			write-host "Warning the OAB URL Value is empty!" -ForegroundColor Red
			
		}
		else
		{
			
		}
		write-host ------------------------------------------------------------------------------------ -ForegroundColor white
		write-host
		write-host
		#  Section 6#7 |  End OAB services information
		
		
		
		#  Section 7#7 |  Start Autodiscover Virtual URL services information
		
		
		write-host
		write-host ************************************************************************  		-ForegroundColor white
		write-host "Information about Exchange Autodiscover virtual directory URL address"          -ForegroundColor white  -BackgroundColor DarkGreen    
		write-host ************************************************************************  		-ForegroundColor white
		
		write-host "Autodiscover virtual directory" -ForegroundColor Yellow
		Get-AutodiscoverVirtualDirectory | FL identity,internalurl, externalurl | Out-String

		$EASDir = Get-AutodiscoverVirtualDirectory
		 if ($EASDir.ExternalUrl -eq $null -or $EASDir.ExternalUrl -eq "")
		{
			write-host "Most of the time this value supposed to be empty !" -ForegroundColor Red
		}
		else
		{
			
		}
		write-host ------------------------------------------------------------------------------------ -ForegroundColor white
		write-host
		write-host
		#  Section 7#7 | End Autodiscover Virtual URL services information
		
		
		#  Section 0 |  Start Exchange Outlook AnyWhere information
		
		
		write-host
		write-host ***************************************************************** 		 -ForegroundColor white
		write-host "Information about Exchange Outlook AnyWhere settings"                    -ForegroundColor white  -BackgroundColor DarkGreen    
		write-host ***************************************************************** 		 -ForegroundColor white
		
		write-host "Outlook AnyWhere settings" -ForegroundColor Yellow
		Get-OutlookAnywhere  |  Out-String

		write-host ------------------------------------------------------------------------------------ -ForegroundColor white
					
					# Folder and path 
					#------------------------------------------------------------------------------

					$A23 =    "C:\INFO\Exchange URL address and Outlook Anywhere information\"
					$A23A2 =  "C:\INFO\Exchange URL address and Outlook Anywhere information\HTML"
					
					if (!(Test-Path -path $A23))
					{
					New-Item $A23 -type directory
					}
										
					if (!(Test-Path -path $A23A2 ))
					{
					New-Item $A23A2  -type directory
					}
					
					#INFO Exchange PowerShell Filtering Examples - http://blogs.technet.com/b/rmilne/archive/2014/03/24/powershell-filtering-examples.aspx
					#  Section 1#7 |  Start Exchange Web services information
		
					$A1 = Get-WebServicesVirtualDirectory | Select  identity,internalurl,externalurl
					$A2 = Get-OwaVirtualDirectory | Select identity,internalurl,externalurl 					
					$A3 = Get-EcpVirtualDirectory | Select identity,internalurl,externalurl
					$A4 = Get-ClientAccessServer | Select identity,AutodiscoverServiceInternalUri 
					$A5 = Get-ActiveSyncVirtualDirectory  | Select identity,internalurl,externalurl
					$A6 = Get-OABVirtualDirectory  | Select identity,internalurl,externalurl
					$A7 = Get-AutodiscoverVirtualDirectory | Select identity,internalurl, externalurl					
					$A8 = Get-OutlookAnywhere | Select PSComputerName,ServerName,ExternalHostname,ClientAuthenticationMethod,@{Name='IISAuthenticationMethods';Expression={$_.IISAuthenticationMethods -join '; '}},Server,ExchangeVersion,OriginatingServer,SSLOffloading

					$body = $A1  | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-web-service.jpg>Get-WebServicesVirtualDirectory</H1></P>" | out-string
					$body += $A2 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-OWA.jpg>Get-OwaVirtualDirectory</H1></P>" | out-string
					$body += $A3 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-OWA.jpg>Get-EcpVirtualDirectory</H1></P>" | out-string
					$body += $A4 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-Autodiscover-services.jpg>Get-ClientAccessServer</H1></P>" | out-string
					$body += $A5 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-ActiveSync.jpg>Get-ActiveSyncVirtualDirectory </H1></P>" | out-string
					$body += $A6 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-OAB-service.jpg>Get-OABVirtualDirectory </H1></P>" | out-string
					$body += $A7 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-Autodiscover-services.jpg>Get-AutodiscoverVirtualDirectory</H1></P>" | out-string
					$body += $A8 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-Outlook-Anywhere.jpg>Get-OutlookAnywhere </H1></P>" | out-string
			
					ConvertTo-Html -Body "$body" -Head $Header -Title "Exchange URL Address report" | Out-File $A23A2\"Exchange web services - Unified report.html"
					
		
						$ie = new-object -comobject "InternetExplorer.Application"  
						$ie.visible = $true  
						$ie.navigate("C:\INFO\Exchange URL address and Outlook Anywhere information\HTML\Exchange web services - Unified report.html") 

					
					
					################################################
					## Exchange 2007 Information
					################################################
					
					
					$A1 =  Get-ExchangeServer | Where {$_.AdminDisplayVersion -like "*8.*" -and $_.IsClientAccessServer} | Get-WebServicesVirtualDirectory | Select  identity,internalurl,externalurl
					$A2 =  Get-ExchangeServer | Where {$_.AdminDisplayVersion -like "*8.*" -and $_.IsClientAccessServer} |Get-OwaVirtualDirectory | Select identity,internalurl,externalurl 					
					$A3 =  Get-ExchangeServer | Where {$_.AdminDisplayVersion -like "*8.*" -and $_.IsClientAccessServer} |Get-EcpVirtualDirectory | Select identity,internalurl,externalurl
					$A4 =  Get-ExchangeServer | Where {$_.AdminDisplayVersion -like "*8.*" -and $_.IsClientAccessServer} |Get-ClientAccessServer | Select identity,AutodiscoverServiceInternalUri 
					$A5 =  Get-ExchangeServer | Where {$_.AdminDisplayVersion -like "*8.*" -and $_.IsClientAccessServer} |Get-ActiveSyncVirtualDirectory  | Select identity,internalurl,externalurl
					$A6 =  Get-ExchangeServer | Where {$_.AdminDisplayVersion -like "*8.*" -and $_.IsClientAccessServer} |Get-OABVirtualDirectory  | Select identity,internalurl,externalurl
					$A7 =  Get-ExchangeServer | Where {$_.AdminDisplayVersion -like "*8.*" -and $_.IsClientAccessServer} |Get-AutodiscoverVirtualDirectory | Select identity,internalurl, externalurl					
					$A8 =  Get-ExchangeServer | Where {$_.AdminDisplayVersion -like "*8.*" -and $_.IsClientAccessServer} |Get-OutlookAnywhere | Select PSComputerName,ServerName,ExternalHostname,ClientAuthenticationMethod,@{Name='IISAuthenticationMethods';Expression={$_.IISAuthenticationMethods -join '; '}},Server,ExchangeVersion,OriginatingServer,SSLOffloading

					$body = $A1  | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-web-service.jpg>Get-WebServicesVirtualDirectory</H1></P>" | out-string
					$body += $A2 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-OWA.jpg>Get-OwaVirtualDirectory</H1></P>" | out-string
					$body += $A3 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-OWA.jpg>Get-EcpVirtualDirectory</H1></P>" | out-string
					$body += $A4 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-Autodiscover-services.jpg>Get-ClientAccessServer</H1></P>" | out-string
					$body += $A5 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-ActiveSync.jpg>Get-ActiveSyncVirtualDirectory </H1></P>" | out-string
					$body += $A6 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-OAB-service.jpg>Get-OABVirtualDirectory </H1></P>" | out-string
					$body += $A7 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-Autodiscover-services.jpg>Get-AutodiscoverVirtualDirectory</H1></P>" | out-string
					$body += $A8 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-Outlook-Anywhere.jpg>Get-OutlookAnywhere </H1></P>" | out-string
			
					ConvertTo-Html -Body "$body" -Head $Header -Title "Exchange URL Address report" | Out-File $A23A2\"Exchange 2007 web services - Unified report.html"
					
					
					
					################################################
					## Exchange 2010 Information
					################################################
					
					
					$A1 =  Get-ExchangeServer | Where {$_.AdminDisplayVersion -like "*14.*" -and $_.IsClientAccessServer} | Get-WebServicesVirtualDirectory | Select  identity,internalurl,externalurl
					$A2 =  Get-ExchangeServer | Where {$_.AdminDisplayVersion -like "*14.*" -and $_.IsClientAccessServer} |Get-OwaVirtualDirectory | Select identity,internalurl,externalurl 					
					$A3 =  Get-ExchangeServer | Where {$_.AdminDisplayVersion -like "*14.*" -and $_.IsClientAccessServer} |Get-EcpVirtualDirectory | Select identity,internalurl,externalurl
					$A4 =  Get-ExchangeServer | Where {$_.AdminDisplayVersion -like "*14.*" -and $_.IsClientAccessServer} |Get-ClientAccessServer | Select identity,AutodiscoverServiceInternalUri 
					$A5 =  Get-ExchangeServer | Where {$_.AdminDisplayVersion -like "*14.*" -and $_.IsClientAccessServer} |Get-ActiveSyncVirtualDirectory  | Select identity,internalurl,externalurl
					$A6 =  Get-ExchangeServer | Where {$_.AdminDisplayVersion -like "*14.*" -and $_.IsClientAccessServer} |Get-OABVirtualDirectory  | Select identity,internalurl,externalurl
					$A7 =  Get-ExchangeServer | Where {$_.AdminDisplayVersion -like "*14.*" -and $_.IsClientAccessServer} |Get-AutodiscoverVirtualDirectory | Select identity,internalurl, externalurl					
					$A8 =  Get-ExchangeServer | Where {$_.AdminDisplayVersion -like "*14.*" -and $_.IsClientAccessServer} |Get-OutlookAnywhere | Select PSComputerName,ServerName,ExternalHostname,ClientAuthenticationMethod,@{Name='IISAuthenticationMethods';Expression={$_.IISAuthenticationMethods -join '; '}},Server,ExchangeVersion,OriginatingServer,SSLOffloading

					$body = $A1  | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-web-service.jpg>Get-WebServicesVirtualDirectory</H1></P>" | out-string
					$body += $A2 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-OWA.jpg>Get-OwaVirtualDirectory</H1></P>" | out-string
					$body += $A3 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-OWA.jpg>Get-EcpVirtualDirectory</H1></P>" | out-string
					$body += $A4 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-Autodiscover-services.jpg>Get-ClientAccessServer</H1></P>" | out-string
					$body += $A5 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-ActiveSync.jpg>Get-ActiveSyncVirtualDirectory </H1></P>" | out-string
					$body += $A6 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-OAB-service.jpg>Get-OABVirtualDirectory </H1></P>" | out-string
					$body += $A7 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-Autodiscover-services.jpg>Get-AutodiscoverVirtualDirectory</H1></P>" | out-string
					$body += $A8 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-Outlook-Anywhere.jpg>Get-OutlookAnywhere </H1></P>" | out-string
			
					ConvertTo-Html -Body "$body" -Head $Header -Title "Exchange URL Address report" | Out-File $A23A2\"Exchange 2010 web services - Unified report.html"
					
					################################################
					## Exchange 2013 Information
					################################################
					
					
					$A1 =  Get-ExchangeServer | Where {$_.AdminDisplayVersion -like "*15.*" -and $_.IsClientAccessServer} | Get-WebServicesVirtualDirectory | Select  identity,internalurl,externalurl
					$A2 =  Get-ExchangeServer | Where {$_.AdminDisplayVersion -like "*15.*" -and $_.IsClientAccessServer} |Get-OwaVirtualDirectory | Select identity,internalurl,externalurl 					
					$A3 =  Get-ExchangeServer | Where {$_.AdminDisplayVersion -like "*15.*" -and $_.IsClientAccessServer} |Get-EcpVirtualDirectory | Select identity,internalurl,externalurl
					$A4 =  Get-ExchangeServer | Where {$_.AdminDisplayVersion -like "*15.*" -and $_.IsClientAccessServer} |Get-ClientAccessServer | Select identity,AutodiscoverServiceInternalUri 
					$A5 =  Get-ExchangeServer | Where {$_.AdminDisplayVersion -like "*15.*" -and $_.IsClientAccessServer} |Get-ActiveSyncVirtualDirectory  | Select identity,internalurl,externalurl
					$A6 =  Get-ExchangeServer | Where {$_.AdminDisplayVersion -like "*15.*" -and $_.IsClientAccessServer} |Get-OABVirtualDirectory  | Select identity,internalurl,externalurl
					$A7 =  Get-ExchangeServer | Where {$_.AdminDisplayVersion -like "*15.*" -and $_.IsClientAccessServer} |Get-AutodiscoverVirtualDirectory | Select identity,internalurl, externalurl					
					$A8 =  Get-ExchangeServer | Where {$_.AdminDisplayVersion -like "*15.*" -and $_.IsClientAccessServer} |Get-OutlookAnywhere | Select PSComputerName,ServerName,ExternalHostname,ClientAuthenticationMethod,@{Name='IISAuthenticationMethods';Expression={$_.IISAuthenticationMethods -join '; '}},Server,ExchangeVersion,OriginatingServer,SSLOffloading

					$body = $A1  | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-web-service.jpg>Get-WebServicesVirtualDirectory</H1></P>" | out-string
					$body += $A2 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-OWA.jpg>Get-OwaVirtualDirectory</H1></P>" | out-string
					$body += $A3 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-OWA.jpg>Get-EcpVirtualDirectory</H1></P>" | out-string
					$body += $A4 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-Autodiscover-services.jpg>Get-ClientAccessServer</H1></P>" | out-string
					$body += $A5 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-ActiveSync.jpg>Get-ActiveSyncVirtualDirectory </H1></P>" | out-string
					$body += $A6 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-OAB-service.jpg>Get-OABVirtualDirectory </H1></P>" | out-string
					$body += $A7 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-Autodiscover-services.jpg>Get-AutodiscoverVirtualDirectory</H1></P>" | out-string
					$body += $A8 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-Outlook-Anywhere.jpg>Get-OutlookAnywhere </H1></P>" | out-string
			
					ConvertTo-Html -Body "$body" -Head $Header -Title "Exchange URL Address report" | Out-File $A23A2\"Exchange 2013 web services - Unified report.html"
					
					
					
					
					Read-Host "Press Enter to continue..."
					write-host
					write-host


		}


		 2
				{

					###############################################################################
					# View information about specific Exchange servers URL address 
					###############################################################################

					# Section 1: information 

						clear-host

						write-host
						write-host
						write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                            
						write-host  -ForegroundColor white		Introduction                                                                                          
						write-host  -ForegroundColor white		--------------------------------------------------------------------------------------                                                              
						write-host  -ForegroundColor white  	'This option will enable us to:  '
						write-host  -ForegroundColor white  	'View information about specific Exchange servers URL address   '
						write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
						write-host

							# Section 2: user input

							write-host
							write-host
							write-host -ForegroundColor Yellow	"1.Type the name of the Exchange server"  
							write-host -ForegroundColor Yellow	"For example: ex02"
							write-host
							$EXSrvName = Read-Host "Type the name of the Exchange server "
							write-host

						
							
							
		####################################################################################################
		# Check Exchange Server Internal + External URL Path
		######################################################################################################

		clear-host

		#  Section 1#7 |  Start Exchange Web services information
		
		write-host "Information about $EXSrvName Exchange Web services virtual directory URL Address" -ForegroundColor Yellow
		write-host
		write-host
		write-host ***************************************************************** -ForegroundColor white
		write-host "$EXSrvName - Information about Exchange Web services URL address "             -ForegroundColor white  -BackgroundColor DarkGreen    
		write-host ***************************************************************** -ForegroundColor white
					

		Get-WebServicesVirtualDirectory -server $EXSrvName | FL identity,internalurl,externalurl | Out-String

		$EWSDir = Get-WebServicesVirtualDirectory -Server $EXSrvName
		 if ($EWSDir.ExternalUrl -eq $null -or $EWSDir.ExternalUrl -eq "")
		{
			write-host "Warning the $EXSrvName Exchange Web services URL Value is empty!" -ForegroundColor Red
		}
		else
		{
			
		}
		write-host ------------------------------------------------------------------------------------ -ForegroundColor white
		write-host
		write-host
		#  Start Exchange Web services information
		
		
		#  Section 2#7 |  Start OWA services information
		write-host
		write-host ***************************************************************** -ForegroundColor white
		write-host "$EXSrvName - Information about Exchange OWA URL address "        -ForegroundColor white  -BackgroundColor DarkGreen    
		write-host ***************************************************************** -ForegroundColor white

		write-host "Information about $EXSrvName Exchange OWA virtual directory URL Address" -ForegroundColor Yellow
	
		Get-OwaVirtualDirectory -Identity "$EXSrvName\owa (default Web site)" | FL identity,internalurl,externalurl | Out-String

		$OWADir = Get-OwaVirtualDirectory -Identity "$EXSrvName\owa (default Web site)"
		 if ($OWADir.ExternalUrl -eq $null -or $OWADir.ExternalUrl -eq "")
		{
			write-host "Warning the $EXSrvName OWA URL Value is empty!" -ForegroundColor Red
		}
		else
		{
			
		}
		write-host ------------------------------------------------------------------------------------ -ForegroundColor white
		write-host
		write-host
		#  End OWA information


		#  Section 3#7 |  Start ECP services information
		write-host
		write-host ***************************************************************** -ForegroundColor white
		write-host "$EXSrvName - Information about Exchange ECP URL address "                      -ForegroundColor white  -BackgroundColor DarkGreen    
		write-host ***************************************************************** -ForegroundColor white
		
		write-host "Information about $EXSrvName Exchange ECP virtual directory URL Address" -ForegroundColor Yellow

		Get-EcpVirtualDirectory  -server $EXSrvName| FL identity,internalurl,externalurl | Out-String

		$ECPDir = Get-EcpVirtualDirectory
		 if ($ECPDir.ExternalUrl -eq $null -or $ECPDir.ExternalUrl -eq "")
		{
			write-host "Warning the ECP URL Value is empty!" -ForegroundColor Red
			write-host "If the server is Exchange CAS 2007 this error is expected" -ForegroundColor Red
		}
		else
		{
			
		}
		write-host ------------------------------------------------------------------------------------ -ForegroundColor white
		write-host
		write-host
		#  End ECP information

		#  Section 4#7 |  Start Autodiscover Active Directory SCP services information
		
			
		
		write-host *****************************************************************       -ForegroundColor white
		write-host "$EXSrvName - Information about Exchange Internal Autodiscover infrastructure  "      -ForegroundColor white  -BackgroundColor DarkGreen 
        write-host "(AutodiscoverServiceInternalUri) "                                     -ForegroundColor white  -BackgroundColor DarkGreen    		
		write-host *****************************************************************       -ForegroundColor white

		write-host "Information about $EXSrvName Exchange Internal Autodiscover infrastructure" -ForegroundColor Yellow
		
		Get-ClientAccessServer -Identity $EXSrvName | FL identity,AutodiscoverServiceInternalUri | Out-String

		$AUTODISDir = Get-ClientAccessServer -Identity $EXSrvName
		 if ($AUTODISDir.AutodiscoverServiceInternalUri -eq $null)
		{
			write-host "Warning the Exchange internal Autodiscover URL Value is empty!" -ForegroundColor Red
		}
		else
		{
			
		}
		write-host ------------------------------------------------------------------------------------ -ForegroundColor white
		write-host
		write-host
		#  End Autodiscover Active Directory SCP information

		
		
		
		 #  Section 5#7 |  Start ActiveSync services information
		
		write-host
		write-host ***************************************************************** -ForegroundColor white
		write-host "$EXSrvName - Information about Exchange ActiveSync URL address  "  -ForegroundColor white  -BackgroundColor DarkGreen    
		write-host ***************************************************************** -ForegroundColor white
		
		write-host "Information about $EXSrvName Exchange ActiveSync virtual directory URL Address" -ForegroundColor Yellow
				
		Get-ActiveSyncVirtualDirectory -server $EXSrvName | FL identity,internalurl,externalurl | Out-String

		$EASDir = Get-ActiveSyncVirtualDirectory  -server $EXSrvName
		 if ($EASDir.ExternalUrl -eq $null -or $EASDir.ExternalUrl -eq "")
		{
			write-host "Warning the ActiveSync URL Value is empty!" -ForegroundColor Red
			write-host "In some scenarios the external URL address should set to NULL" -ForegroundColor Red
		}
		else
		{
			
		}
		write-host ------------------------------------------------------------------------------------ -ForegroundColor white
		write-host
		write-host
		#  End ActiveSync information

		
		#  Section 6#7 |  Start OAB services information
		
		write-host
		write-host ***************************************************************** -ForegroundColor white
		write-host "$EXSrvName - Information about Exchange OAB  URL address"                     -ForegroundColor white  -BackgroundColor DarkGreen    
		write-host ***************************************************************** -ForegroundColor white
		
		write-host "Information about $EXSrvName Exchange OAB virtual directory URL Address" -ForegroundColor Yellow
		
		
		Get-OABVirtualDirectory -Server $EXSrvName | FL identity,internalurl,externalurl | Out-String

		$OABDir = Get-OABVirtualDirectory 
		 if ($OABDir.ExternalUrl -eq $null -or $OABDir.ExternalUrl -eq "")
		{
			write-host "Warning the OAB URL Value is empty!" -ForegroundColor Red
			
		}
		else
		{
			
		}
		write-host ------------------------------------------------------------------------------------ -ForegroundColor white
		write-host
		write-host
		#  End OAB information

		
		#  Section 7#7 |  Start Autodiscover Virtual URL services information
		
		
		write-host
		write-host ************************************************************************  		-ForegroundColor white
		write-host "$EXSrvName - Information about Exchange Autodiscover virtual directory URL address"          -ForegroundColor white  -BackgroundColor DarkGreen    
		write-host ************************************************************************  		-ForegroundColor white
		
		write-host "Information about $EXSrvName Exchange Autodiscover virtual directory URL Address" -ForegroundColor Yellow
				
		Get-AutodiscoverVirtualDirectory -server $EXSrvName | FL identity,internalurl, externalurl | Out-String

		$EASDir = Get-AutodiscoverVirtualDirectory -server $EXSrvName
		 if ($EASDir.ExternalUrl -eq $null -or $EASDir.ExternalUrl -eq "")
		{
			write-host "Most of the time this value supposed to be empty !" -ForegroundColor Red
		}
		else
		{
			
		}
		write-host ------------------------------------------------------------------------------------ -ForegroundColor white
		write-host
		write-host
		#  End Autodiscover Virtual directory information

		
		#  Section 0 |  Start Exchange Outlook AnyWhere information

			
		write-host
		write-host ***************************************************************** 		 -ForegroundColor white
		write-host "Information about Exchange Outlook AnyWhere settings"                    -ForegroundColor white  -BackgroundColor DarkGreen    
		write-host ***************************************************************** 		 -ForegroundColor white

		write-host "Information about $EXSrvName Outlook AnyWhere settings" -ForegroundColor Yellow
		Get-OutlookAnywhere -Server $EXSrvName
		#  End Outlook AnyWhere settings information

		write-host ------------------------------------------------------------------------------------ -ForegroundColor white
		write-host
		write-host
		 
		
					# Folder and path 
					#------------------------------------------------------------------------------

					$A23 =    "C:\INFO\Exchange URL address and Outlook Anywhere information\"
					$A23A2 =  "C:\INFO\Exchange URL address and Outlook Anywhere information\HTML"
					
					if (!(Test-Path -path $A23))
					{
					New-Item $A23 -type directory
					}
										
					if (!(Test-Path -path $A23A2 ))
					{
					New-Item $A23A2  -type directory
					}
					
				
					
					#  Section 1#7 |  Start Exchange Web services information
		

										
					$A1 = Get-WebServicesVirtualDirectory -server $EXSrvName | Select identity,internalurl,externalurl
					$A2 = Get-OwaVirtualDirectory -Identity "$EXSrvName\owa (default Web site)" | Select identity,internalurl,externalurl					
					$A3 = Get-EcpVirtualDirectory  -server $EXSrvName| Select identity,internalurl,externalurl
					$A4 = Get-ClientAccessServer -Identity $EXSrvName | Select identity,AutodiscoverServiceInternalUri
					$A5 = Get-ActiveSyncVirtualDirectory -server $EXSrvName | Select identity,internalurl,externalurl 
					$A6 = Get-OABVirtualDirectory -Server $EXSrvName | Select identity,internalurl,externalurl
					$A7 = Get-AutodiscoverVirtualDirectory -server $EXSrvName | Select identity,internalurl, externalurl				
					$A8 = Get-OutlookAnywhere -Server $EXSrvName  | Select PSComputerName,ServerName,ExternalHostname,ClientAuthenticationMethod,@{Name='IISAuthenticationMethods';Expression={$_.IISAuthenticationMethods -join '; '}},Server,ExchangeVersion,OriginatingServer,SSLOffloading

					$body = $A1  | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-web-service.jpg>Get-WebServicesVirtualDirectory</H1></P>" | out-string
					$body += $A2 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-OWA.jpg>Get-OwaVirtualDirectory</H1></P>" | out-string
					$body += $A3 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-OWA.jpg>Get-EcpVirtualDirectory</H1></P>" | out-string
					$body += $A4 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-Autodiscover-services.jpg>Get-ClientAccessServer</H1></P>" | out-string
					$body += $A5 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-ActiveSync.jpg>Get-ActiveSyncVirtualDirectory </H1></P>" | out-string
					$body += $A6 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-OAB-service.jpg>Get-OABVirtualDirectory </H1></P>" | out-string
					$body += $A7 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-Autodiscover-services.jpg>Get-AutodiscoverVirtualDirectory</H1></P>" | out-string
					$body += $A8 | ConvertTo-Html -Fragment -PreContent "<P><H1><img src=http://o365info.com/wp-content/gallery/icons/Exchange-Outlook-Anywhere.jpg>Get-OutlookAnywhere </H1></P>" | out-string
			
					ConvertTo-Html -Body "$body" -Head $Header -Title "Exchange URL Address report" | Out-File $A23A2\"$EXSrvName -Exchange web services.html"
					
		
						$ie = new-object -comobject "InternetExplorer.Application"  
						$ie.visible = $true  
						$ie.navigate("C:\INFO\Exchange URL address and Outlook Anywhere information\HTML\$EXSrvName -Exchange web services.html")  
		 
		 
		 
		Read-Host "Press Enter to continue..."
		write-host
		write-host


				}




		#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
		#B: Manage Exchange servers URL address
		#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@




				 3
				{

					###############################################################################
					# Manage Exchange 2007 CAS Server URL address   
					###############################################################################

					# Section 1: information 

						clear-host

						write-host
						write-host
						write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                            
						write-host  -ForegroundColor white		Introduction                                                                                          
						write-host  -ForegroundColor white		--------------------------------------------------------------------------------------                                                              
						write-host  -ForegroundColor white  	'The following menu enable us to set the internal + the external URL address of the   '
						write-host  -ForegroundColor white  	'following Exchange CAS services:  '
						write-host  -ForegroundColor white  	'1.	Exchange web service  '
						write-host  -ForegroundColor white  	'2.	Exchange OWA  '
						write-host  -ForegroundColor white  	'3.	Exchange ECP  '
						write-host  -ForegroundColor white  	'4.	Exchange ActiveSync  '
						write-host  -ForegroundColor white  	'The URL address that we choose will be apply to all of this services   '						
						write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
						write-host
						
						
				write-host 	Choose the required option    														-ForegroundColor white                                                                                      
				write-host ------------------------------------------------------------------------------------ -ForegroundColor white   
				
				$decision = Read-Host "Choose the required option by entering the letter of your choice   
				 `n[A] Set the URL address of Exchange web services - Use an identical namespace for internal and external URL address 
				 `n[B] Set the URL address of Exchange web services - Use different namespace for internal versus external URL address 				
				 " 
				 
				 
				do
				{
					$verified = Validate-UserSelection -ErrorMessage "Please choose between A, B" -Selection $decision -AllowedAnswers "A,B"
					if(-not($verified))
					{
						$decision = Read-Host "Choose the required option by entering the letter of your choice:"
					}
				}
				while(-not($verified))
	 
				
				if ($decision -eq "A")
				{
				
					# Section 1: Information 
					
					    write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                            
						write-host  -ForegroundColor white		Introduction                                                                                          
						write-host  -ForegroundColor white		--------------------------------------------------------------------------------------                                                              
						write-host  -ForegroundColor white  	'This option will: Set the URL address of Exchange web services   '
						write-host  -ForegroundColor white  	'Using an identical namespace for internal and external URL address  '
						write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
						write-host
	
						

							# Section 2: user input

								write-host
								write-host
								write-host -ForegroundColor Yellow	"1. Specify the name of the Exchange server that you would like to set"  
								write-host -ForegroundColor Yellow	"For example: For example: ex02"
								write-host -ForegroundColor Yellow	"and Press The ENTER Key"
								write-host
								$EXSrvName = Read-Host "Specify the name of the Exchange server that you would like to set "
								write-host
								write-host
								write-host
								write-host -ForegroundColor Yellow	"2. Type the host name (FQDN) The will serve for the internal + the external URL address"  
								write-host -ForegroundColor Yellow	"For example: For example: mail.o365info.com"
								write-host -ForegroundColor Yellow	"and Press The ENTER Key"
								write-host
								$EXFQDN = Read-Host " Type the host name (FQDN) The will serve for the internal + the external URL address "
								write-host
							
							
		####################################################################################################
		# configure Exchange Server - Internal + External URL Path
		######################################################################################################

		clear-host

		
		#################################################################################################################################
		#              Section 1#5 | Exchange Web services  configurations
		#################################################################################################################################
		
		
		write-host
		write-host *******************************************************************************************         -ForegroundColor white
		write-host "Set $EXSrvName Exchange web service Internal + External URL address using the host name:"           -ForegroundColor white  -BackgroundColor DarkGreen 
		write-host "$EXFQDN"          																				   -ForegroundColor white  	
		write-host *******************************************************************************************         -ForegroundColor white
		
				
		Get-WebServicesVirtualDirectory -Server $EXSrvName | Set-WebServicesVirtualDirectory -InternalURL "https://$EXFQDN/EWS/Exchange.asmx" -ExternalURL "https://$EXFQDN/EWS/Exchange.asmx"
		write-host "Results:"	
	
		$EWSDir = Get-WebServicesVirtualDirectory -Server $EXSrvName
		 if ($EWSDir.ExternalUrl -eq $null -or $EWSDir.ExternalUrl -eq "")
		{
			write-host "Warning the $EXSrvName Exchange Web services URL Value is empty!" -ForegroundColor Red
		}
		else
		{
		write-host "The command complete successfully" -ForegroundColor green
		write-host "The Exchange web service Internal URL is:"$EWSDir.InternalUrl.ToString()" " -ForegroundColor green
		write-host "The Exchange web service External URL is:"$EWSDir.InternalUrl.ToString()" " -ForegroundColor green
		
		}
	
		#  End Exchange Web services configurations

		#  Start Exchange Web services information
		write-host
		write-host		
		
		write-host "$EXSrvName - information about Exchange Web services URLs"     						-ForegroundColor Yellow  -BackgroundColor DarkGreen    
		write-host ------------------------------------------------------------------------------------ -ForegroundColor white   
		Get-WebServicesVirtualDirectory -server $EXSrvName | FL identity,internalurl,externalurl | Out-String
		write-host ------------------------------------------------------------------------------------ -ForegroundColor white   
		write-host
		
		
		
		#################################################################################################################################		
		#  End Exchange Web services information
		#  Section 1#5 |  END Exchange Web services configurations	
		#################################################################################################################################		
		
		
		
		#################################################################################################################################
		#              Section 2#5 | OWA configurations
		#################################################################################################################################
		
		
		write-host
		write-host *******************************************************************************************         -ForegroundColor white
		write-host "Set $EXSrvName OWA Services Internal + External URL address using the host name:"                  -ForegroundColor white  -BackgroundColor DarkGreen 
		write-host "$EXFQDN"          																				   -ForegroundColor white  	
		write-host *******************************************************************************************         -ForegroundColor white
		
		write-host "Results:"
	    Set-OwaVirtualDirectory "$EXSrvName\owa (Default Web Site)" -ExternalUrl https://$EXFQDN/owa -InternalUrl https://$EXFQDN/owa
			
		$OWADir = Get-OwaVirtualDirectory -Identity "$EXSrvName\owa (default Web site)"
		 if ($OWADir.ExternalUrl -eq $null -or $OWADir.ExternalUrl -eq "")
		{
			write-host "Warning the $EXSrvName OWA URL Value is empty!" -ForegroundColor Red
		}
		else
		{
		write-host "The command complete successfully" -ForegroundColor green
		write-host "The Exchange OWA Internal URL is:"$OWADir.InternalUrl.ToString()" " -ForegroundColor green
		write-host "The Exchange OWA External URL is:"$OWADir.InternalUrl.ToString()" " -ForegroundColor green
		}
		#  End Exchange OWA configurations
		
		
		write-host
		write-host	
		
		#  Start OWA information
		write-host "$EXSrvName - information about OWA Web services URLs"     						    -ForegroundColor Yellow  -BackgroundColor DarkGreen    
		write-host ------------------------------------------------------------------------------------ -ForegroundColor white   
		Get-OwaVirtualDirectory -Identity "$EXSrvName\owa (default Web site)" | FL identity,internalurl,externalurl | Out-String
		write-host ------------------------------------------------------------------------------------ -ForegroundColor white   
		write-host
		write-host
		
			
		
		#################################################################################################################################
		#  End OWA information
		#  Section 2#5 | END Exchange OWA configurations	
		#################################################################################################################################
		
		
		
		#################################################################################################################################
		#              Section 3#5 | ECP configurations
		#################################################################################################################################
				
				
		write-host
		write-host *******************************************************************************************         -ForegroundColor white
		write-host "Set $EXSrvName ECP Services Internal + External URL address using the host name:"                  -ForegroundColor white  -BackgroundColor DarkGreen 
		write-host "$EXFQDN"          																				   -ForegroundColor white   		
		write-host *******************************************************************************************         -ForegroundColor white
	    
		
		Set-EcpVirtualDirectory "$EXSrvName\ECP (Default Web Site)" -ExternalUrl https://$EXFQDN/ecp -InternalUrl https://$EXFQDN/ecp
		
		write-host "Results:"		
		$ECPDir = Get-EcpVirtualDirectory  "$EXSrvName\ECP (Default Web Site)" 
		 if ($ECPDir.ExternalUrl -eq $null -or $ECPDir.ExternalUrl -eq "")
		{
			write-host "Warning the $EXSrvName ECP URL Value is empty!" -ForegroundColor Red
			write-host " In case that you get this output from Exchange 2007 client, its OK" -ForegroundColor Red	

		}
		else
		{
		write-host "The command complete successfully" -ForegroundColor green
		write-host "The Exchange OWA Internal URL is:"$ECPDir.InternalUrl.ToString()" " -ForegroundColor green
		write-host "The Exchange OWA External URL is:"$ECPDir.InternalUrl.ToString()" " -ForegroundColor green
		}
		#  End Exchange ECP configurations
				
		#  Start ECP information
		
		write-host
		write-host	
		write-host "$EXSrvName - information about ECP Web services URLs"     						    -ForegroundColor Yellow  -BackgroundColor DarkGreen    
		write-host ------------------------------------------------------------------------------------ -ForegroundColor white   
		
		Get-EcpVirtualDirectory  "$EXSrvName\ECP (Default Web Site)" | FL identity,internalUrl,externalUrl | Out-String
		
		write-host ------------------------------------------------------------------------------------ -ForegroundColor white   
		write-host
		write-host	
		
		#################################################################################################################################
		#  End ECP information
		#  Section 3#5 | END Exchange ECP configurations
		#################################################################################################################################
		
		
		#################################################################################################################################
		#              Section 4#5 | ActiveSync configurations
		#################################################################################################################################
				
		
		write-host
		write-host *******************************************************************************************         -ForegroundColor white
		write-host "Set $EXSrvName ActiveSync Services Internal + External URL address using the host name:"           -ForegroundColor white  -BackgroundColor DarkGreen 
		write-host "$EXFQDN"          																				   -ForegroundColor white   		
		write-host *******************************************************************************************         -ForegroundColor white
		
		Get-ActiveSyncVirtualDirectory -Server $EXSrvName | Set-ActiveSyncVirtualDirectory -InternalURL "https://$EXFQDN/Microsoft-Server-ActiveSync" -ExternalURL $null
		
		write-host "Results:"
		$EASDir = Get-ActiveSyncVirtualDirectory  -server $EXSrvName
		 if ($EASDir.ExternalUrl -eq $null -or $EASDir.ExternalUrl -eq "")
		{
			write-host "Warning the ActiveSync URL Value is empty!" -ForegroundColor Red
			write-host "In some scenarios the external URL address should set to NULL" -ForegroundColor Red
		}
		else
		{
		write-host "The command complete successfully" -ForegroundColor green
		write-host "The Exchange OWA Internal URL is:"$EASDir.InternalUrl.ToString()" " -ForegroundColor green
		write-host "The Exchange OWA External URL is:"$EASDir.InternalUrl.ToString()" " -ForegroundColor green	
		}
	   
		#  Start ActiveSync information
				
		
		write-host
		write-host	
		write-host "$EXSrvName - information about  ActiveSync Web services URLs"     					-ForegroundColor Yellow  -BackgroundColor DarkGreen    
		write-host ------------------------------------------------------------------------------------ -ForegroundColor white   
		
		Get-ActiveSyncVirtualDirectory -server $EXSrvName | FL identity,internalUrl,externalUrl | Out-String
		
		write-host ------------------------------------------------------------------------------------ -ForegroundColor white   
		write-host
		write-host	
				
		
		
		#  End ActiveSync information
		#  Section 4#5 | END Exchange ActiveSync configurations
		
		
		#################################################################################################################################
		#              Section 5#5 | OAB configurations
		#################################################################################################################################
		
		
		write-host
		write-host *******************************************************************************************         -ForegroundColor white
		write-host "Set $EXSrvName OAB Services Internal + External URL address using the host name:"                  -ForegroundColor white  -BackgroundColor DarkGreen 
		write-host "$EXFQDN"          																				   -ForegroundColor white  
		write-host *******************************************************************************************         -ForegroundColor white
		
		
		Get-OABVirtualDirectory -Server $EXSrvName | Set-OABVirtualDirectory -InternalURL "https://$EXFQDN/OAB" -ExternalURL "https://$EXFQDN/OAB"
		write-host "Results:"
		$OABDir = Get-OABVirtualDirectory -Server $EXSrvName
		 if ($OABDir.ExternalURL -eq $null -or $OABDir.ExternalURL -eq "")
		{
			write-host "Warning the OAB URL Value is empty!" -ForegroundColor Red
			
		}
		else
		{
		write-host "The command complete successfully" -ForegroundColor green
		write-host "The Exchange OWA Internal URL is:"$OABDir.InternalUrl.ToString()" " -ForegroundColor green
		write-host "The Exchange OWA External URL is:"$OABDir.InternalUrl.ToString()" " -ForegroundColor green	
		}
		
				#  Start OAB information
		
		write-host
		write-host	
		write-host "$EXSrvName - information about OAB services URLs"     						        -ForegroundColor Yellow  -BackgroundColor DarkGreen    
		write-host ------------------------------------------------------------------------------------ -ForegroundColor white   
		
		Get-OABVirtualDirectory -Server $EXSrvName | FL identity,internalUrl,externalUrl | Out-String
		
		write-host ------------------------------------------------------------------------------------ -ForegroundColor white   
		write-host
		write-host	
			
		
		#  End OAB information
		#  Section 5#5 | END Exchange OAB configurations
		
		Read-Host "Press Enter to continue..."
		write-host
		write-host

		}



				
	
				if ($decision -eq "B")
				{
				
					# Section 1: Information 
					
					     write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                            
						write-host  -ForegroundColor white		Introduction                                                                                          
						write-host  -ForegroundColor white		--------------------------------------------------------------------------------------                                                              
						write-host  -ForegroundColor white  	'This option will: Set the URL address of Exchange web services   '
						write-host  -ForegroundColor white  	'Using NON identical namespace for internal and external URL address  '
						write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
						write-host
						

							# Section 2: user input

								write-host
								write-host
								write-host -ForegroundColor Yellow	"1. Type the name of the Exchange server"  
								write-host -ForegroundColor Yellow	"For example: For example: ex02"
								write-host -ForegroundColor Yellow	"and Press The ENTER Key"
								write-host
								$EXSrvName = Read-Host "Type the name of the Exchange server "
								write-host
								write-host
								write-host
								write-host -ForegroundColor Yellow	"2. Type the External host name (FQDN) of Exchange service"  
								write-host -ForegroundColor Yellow	"For example: For example: mail.o365info.com"
								write-host -ForegroundColor Yellow	"and Press The ENTER Key"
								write-host
								$EXFQDNExt = Read-Host "Type the External host name (FQDN) of Exchange service "
								write-host
								write-host
								write-host -ForegroundColor Yellow	"3. Type the Internal host name (FQDN) of Exchange service"  
								write-host -ForegroundColor Yellow	"For example: For example: ex01.o365info.local"
								write-host -ForegroundColor Yellow	"and Press The ENTER Key"
								write-host
								$EXFQDNInt = Read-Host "Type the Internal host name (FQDN) of Exchange service "
								write-host
							
		####################################################################################################
		# configure Exchange Server - Internal + External URL Path
		######################################################################################################

		clear-host

		
		#################################################################################################################################
		#              Section 1#5 | Exchange Web services  configurations
		#################################################################################################################################
		
		
		write-host "Set $EXSrvName Exchange web service Internal URL address using the host name:$EXFQDNInt " -ForegroundColor white
		write-host "Set $EXSrvName Exchange web service External URL address using the host name:$EXFQDNExt" -ForegroundColor Yellow
	
		write-host
		
		Get-WebServicesVirtualDirectory -Server $EXSrvName | Set-WebServicesVirtualDirectory -InternalURL "https://$EXFQDNInt/EWS/Exchange.asmx" -ExternalURL "https://$EXFQDNExt/EWS/Exchange.asmx"
	
		$EWSDir = Get-WebServicesVirtualDirectory -Server $EXSrvName
		 if ($EWSDir.ExternalUrl -eq $null -or $EWSDir.ExternalUrl -eq "")
		{
			write-host "Warning the $EXSrvName Exchange Web services URL Value is empty!" -ForegroundColor Red
		}
		else
		{
		write-host "The command complete successfully" -ForegroundColor green
		write-host "The Exchange web service Internal URL is:"$EWSDir.InternalUrl.ToString()" " -ForegroundColor green
		write-host "The Exchange web service External URL is:"$EWSDir.InternalUrl.ToString()" " -ForegroundColor green
		
		}
	
		#  End Exchange Web services configurations

		#  Start Exchange Web services information
		write-host "Check $EXSrvName Exchange Server Internal + External URL Path" -ForegroundColor Yellow
		write-host
		write-host		
		write-host ----------------------------------------------------------------------------------------------------
		write-host "$EXSrvName - Exchange Web services URLs" -ForegroundColor white  -BackgroundColor DarkGreen    
		write-host ----------------------------------------------------------------------------------------------------
		write-host
				
		Get-WebServicesVirtualDirectory -server $EXSrvName | FL identity,internalurl,externalurl | Out-String
		
		write-host
		write-host	
		
		
		#################################################################################################################################		
		#  End Exchange Web services information
		#  Section 1#5 |  END Exchange Web services configurations	
		#################################################################################################################################		
		
		
		
		#################################################################################################################################
		#              Section 2#5 | OWA configurations
		#################################################################################################################################
		
		
		write-host "Set $EXSrvName OWA Internal URL address using the host name:$EXFQDNInt " -ForegroundColor white
		write-host "Set $EXSrvName OWA External URL address using the host name:$EXFQDNExt" -ForegroundColor Yellow
		write-host
		
	    Set-OwaVirtualDirectory "$EXSrvName\owa (Default Web Site)"  -ExternalUrl https://$EXFQDNExt/owa -InternalUrl https://$EXFQDNInt/owa
			
		$OWADir = Get-OwaVirtualDirectory -Identity "$EXSrvName\owa (default Web site)"
		 if ($OWADir.ExternalUrl -eq $null -or $OWADir.ExternalUrl -eq "")
		{
			write-host "Warning the $EXSrvName OWA URL Value is empty!" -ForegroundColor Red
		}
		else
		{
		write-host "The command complete successfully" -ForegroundColor green
		write-host "The Exchange OWA Internal URL is:"$OWADir.InternalUrl.ToString()" " -ForegroundColor green
		write-host "The Exchange OWA External URL is:"$OWADir.InternalUrl.ToString()" " -ForegroundColor green
		}
		#  End Exchange OWA configurations
		
		
		
		#  Start OWA information
		write-host		
		write-host ----------------------------------------------------------------------------------------------------
		write-host "$EXSrvName - Exchange OWA URLs address information" -ForegroundColor white  -BackgroundColor DarkGreen    
		write-host ----------------------------------------------------------------------------------------------------
		write-host
				
		Get-OwaVirtualDirectory -Identity "$EXSrvName\owa (default Web site)" | FL identity,internalurl,externalurl | Out-String
		
		write-host
		write-host	
		write-host	
		
			
		
		#################################################################################################################################
		#  End OWA information
		#  Section 2#5 | END Exchange OWA configurations	
		#################################################################################################################################
		
		
		
		#################################################################################################################################
		#              Section 3#5 | ECP configurations
		#################################################################################################################################
				
				
		write-host "Set $EXSrvName ECP Internal URL address using the host name:$EXFQDNInt " -ForegroundColor white
		write-host "Set $EXSrvName ECP External URL address using the host name:$EXFQDNExt" -ForegroundColor Yellow
		write-host
		
	    
		
		Set-EcpVirtualDirectory "$EXSrvName\ECP (Default Web Site)" -ExternalUrl https://$EXFQDNExt/ecp -InternalUrl https://$EXFQDNInt/ecp
			
		$ECPDir = Get-EcpVirtualDirectory  "$EXSrvName\ECP (Default Web Site)" 
		 if ($ECPDir.ExternalUrl -eq $null -or $ECPDir.ExternalUrl -eq "")
		{
			write-host "Warning the $EXSrvName ECP URL Value is empty!" -ForegroundColor Red
			write-host " In case that you get this output from Exchange 2007 client, its OK" -ForegroundColor Red	

		}
		else
		{
		write-host "The command complete successfully" -ForegroundColor green
		write-host "The Exchange OWA Internal URL is:"$ECPDir.InternalUrl.ToString()" " -ForegroundColor green
		write-host "The Exchange OWA External URL is:"$ECPDir.InternalUrl.ToString()" " -ForegroundColor green
		}
		#  End Exchange ECP configurations
				
		#  Start ECP information
		
		write-host		
		write-host ----------------------------------------------------------------------------------------------------
		write-host "$EXSrvName - Exchange ECP URLs address information" -ForegroundColor white  -BackgroundColor DarkGreen    
		write-host ----------------------------------------------------------------------------------------------------
		write-host
		
		Get-EcpVirtualDirectory  "$EXSrvName\ECP (Default Web Site)"  | FL identity,internalUrl,externalUrl | Out-String
		
		write-host
		write-host	
		write-host	
		
		#################################################################################################################################
		#  End ECP information
		#  Section 3#5 | END Exchange ECP configurations
		#################################################################################################################################
		
		
		#################################################################################################################################
		#              Section 4#5 | ActiveSync configurations
		#################################################################################################################################
				
		
		write-host "Set $EXSrvName ActiveSync Internal URL address using the host name:$EXFQDNInt " -ForegroundColor white
		write-host "Set $EXSrvName ActiveSync External URL address using the host name:null" -ForegroundColor Yellow
		write-host
		
		Get-ActiveSyncVirtualDirectory -Server $EXSrvName | Set-ActiveSyncVirtualDirectory  -ExternalURL $null -InternalURL "https://$EXFQDNInt/Microsoft-Server-ActiveSync"

		$EASDir = Get-ActiveSyncVirtualDirectory  -server $EXSrvName
		 if ($EASDir.ExternalUrl -eq $null -or $EASDir.ExternalUrl -eq "")
		{
			write-host "Warning the ActiveSync URL Value is empty!" -ForegroundColor Red
			write-host "In some scenarios the external URL address should set to NULL" -ForegroundColor Red
		}
		else
		{
		write-host "The command complete successfully" -ForegroundColor green
		write-host "The Exchange OWA Internal URL is:"$EASDir.InternalUrl.ToString()" " -ForegroundColor green
		write-host "The Exchange OWA External URL is:"$EASDir.InternalUrl.ToString()" " -ForegroundColor green	
		}
	   
		#  Start ActiveSync information
				
		write-host		
		write-host ----------------------------------------------------------------------------------------------------
		write-host "$EXSrvName - Exchange ActiveSync URLs"  -ForegroundColor white  -BackgroundColor DarkGreen    
		write-host ----------------------------------------------------------------------------------------------------
		write-host
		
		Get-ActiveSyncVirtualDirectory -server $EXSrvName | FL identity,internalUrl,externalUrl | Out-String
		
		write-host
		write-host	
		write-host	
				
		
		
		#  End ActiveSync information
		#  Section 4#5 | END Exchange ActiveSync configurations
		
		
		#################################################################################################################################
		#              Section 5#5 | OAB configurations
		#################################################################################################################################
				
		write-host "Set $EXSrvName OAB Internal URL address using the host name:$EXFQDNInt " -ForegroundColor white
		write-host "Set $EXSrvName OAB External URL address using the host name:$EXFQDNExt" -ForegroundColor Yellow
		write-host
		Get-OABVirtualDirectory -Server $EXSrvName | Set-OABVirtualDirectory  -ExternalURL "https://$EXFQDNExt/OAB" -InternalURL "https://$EXFQDNInt/OAB"
				
		$OABDir = Get-OABVirtualDirectory -Server $EXSrvName
		 if ($OABDir.ExternalURL -eq $null -or $OABDir.ExternalURL -eq "")
		{
			write-host "Warning the OAB URL Value is empty!" -ForegroundColor Red
			
		}
		else
		{
		write-host "The command complete successfully" -ForegroundColor green
		write-host "The Exchange OWA Internal URL is:"$OABDir.InternalUrl.ToString()" " -ForegroundColor green
		write-host "The Exchange OWA External URL is:"$OABDir.InternalUrl.ToString()" " -ForegroundColor green	
		}
		
				#  Start OAB information
		
		write-host		
		write-host ----------------------------------------------------------------------------------------------------
		write-host  "$EXSrvName - Exchange OAB URLs"  -ForegroundColor white  -BackgroundColor DarkGreen    
		write-host ----------------------------------------------------------------------------------------------------
		write-host
		
		Get-OABVirtualDirectory -Server $EXSrvName | FL identity,internalUrl,externalUrl | Out-String
		
		write-host
		write-host	
		write-host	
			
		
		#  End OAB information
		#  Section 5#5 | END Exchange OAB configurations
		
		

					# END of B Selection 
				
				}
				
				
				else
					{
					  Write-Host "Choose the required option by entering the letter of your choice"
					}


		Read-Host "Press Enter to continue..."
		write-host
		write-host

		}
		
						
						
						
						

#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#C: Manage Exchange servers Autodiscover SCP URL address    
#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
				
			 4
				{

					###############################################################################
					# Manage Exchange servers Autodiscover SCP URL address 
					###############################################################################

					# Section 1: information 

						clear-host

						write-host
						write-host
						write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                             
						write-host  -ForegroundColor white		Introduction                                                                                          
						write-host  -ForegroundColor white		---------------------------------------------------------------------------------------------------------                                                               
						write-host  -ForegroundColor white  	'This option will set the value of the Autodiscover value that is registred in the AD SCP URL address  '
						write-host  -ForegroundColor white  	'The value that will be configured is the - AutoDiscoverServiceInternalUri '
						write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                                 
						write-host

								# Section 2: user input

								write-host
								write-host
								write-host -ForegroundColor Yellow	"1. Type the name of the Exchange server"  
								write-host -ForegroundColor Yellow	"For example: For example: EX02"
								write-host -ForegroundColor Yellow	"and Press The ENTER Key"
								write-host
								$EXSrvName = Read-Host "Type the name of the Exchange server "
								write-host
								write-host
								write-host
								write-host -ForegroundColor Yellow	"2. Type the FQDN name of the Exchange server FQDN "  
								write-host -ForegroundColor Yellow	"For example: autodiscover.o365info.com"
								write-host -ForegroundColor Yellow	"and Press The ENTER Key"
								write-host
								$EXFQDN = Read-Host "Type the FQDN name of the Exchange server FQDN "
								write-host
		
		#  Section 4#6 | Start Autodiscover Active Directory SCP  configurations
		write-host "Set $EXSrvName  Active Directory SCP URL address using the host name" -ForegroundColor Yellow
		write-host "https://$EXFQDN/autodiscover/autodiscover.xml"  -ForegroundColor white
		write-host
		
	    Set-ClientAccessServer -Identity "$EXSrvName" -AutoDiscoverServiceInternalUri "https://$EXFQDN/autodiscover/autodiscover.xml" 
			
		$AUTODISDir = Get-ClientAccessServer -Identity $EXSrvName
		 if ($AUTODISDir.AutodiscoverServiceInternalUri -eq $null)
		{
			write-host "Warning the Exchange internal Autodiscover URL Value is empty!" -ForegroundColor Red
		}
		else
		{
		write-host "The command completed successfully!" -ForegroundColor green
		write-host "The Exchange Active Directory SCP URL address is:"$AUTODISDir.AutodiscoverServiceInternalUri.ToString()" " -ForegroundColor green
				
		}
								
		# Display information on the screen
		
		write-host	
		write-host	
		write-host		
		write-host ----------------------------------------------------------------------------------------------------
		write-host "$EXSrvName - Autodiscover Active Directory SCP information "   -ForegroundColor white  -BackgroundColor DarkGreen    
		write-host ----------------------------------------------------------------------------------------------------
		write-host
		
		Get-ClientAccessServer -Identity $EXSrvName | FL identity,AutodiscoverServiceInternalUri | Out-String
		
		write-host
		write-host	
		write-host	
			
		
		
		
		
		
		# END Autodiscover Active Directory SCP  configurations
		
		Read-Host "Press Enter to continue..."
		write-host
		write-host

}
		
		


#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#D: Manage Outlook Anywhere settings  
#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

		5{

		####################################################################################################
		# view Outlook AnyWhere settings
		######################################################################################################

			clear-host
		
		# Section 1: Information 
					
					    write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                            
						write-host  -ForegroundColor white		Introduction                                                                                          
						write-host  -ForegroundColor white		--------------------------------------------------------------------------------------                                                              
						write-host  -ForegroundColor white  	'This option will: Display Outlook Anywhere setting '
						write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
						write-host
		
		# Section 0: decision 

				write-host  -ForegroundColor white		Choose the required option                                                                                          
				write-host  -ForegroundColor white		----------------------------------------------------------------------------    
				$decision = Read-Host "Choose the required option by entering the letter of your choice   
				 `n[A] Display Outlook Anywhere setting on all of the existing Exchange CAS servers  
				 `n[B] Display Outlook Anywhere setting of a specific Exchange CAS server  				
				 " 
				 
				 
				do
				{
					$verified = Validate-UserSelection -ErrorMessage "Please choose between A, B" -Selection $decision -AllowedAnswers "A,B"
					if(-not($verified))
					{
						$decision = Read-Host "Choose the required option by entering the letter of your choice:"
					}
				}
				while(-not($verified))
	 
				
				if ($decision -eq "A")
				{
				
					# Section 1: Information 
					
					    write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                             
						write-host  -ForegroundColor white		Introduction                                                                                          
						write-host  -ForegroundColor white		--------------------------------------------------------------------------------------------------------                                                             
						write-host  -ForegroundColor white  	'This option will: Display Outlook Anywhere setting on all of the existing Exchange CAS servers  '
						write-host  -ForegroundColor white		--------------------------------------------------------------------------------------------------------    
						write-host  -ForegroundColor white  	'The PowerShell command syntax that we use is:  '
						write-host  -ForegroundColor white  	'Get-OutlookAnywhere  '						
					    write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                                
						write-host
	
						# Section 3: Display results on screen (PowerShell Command)
					
						write-host	
						write-host	
						write-host		
						write-host ----------------------------------------------------------------------------------------------------
						write-host "Outlook AnyWhere settings"  -ForegroundColor white  -BackgroundColor DarkGreen    
						write-host ----------------------------------------------------------------------------------------------------
						write-host
						Get-OutlookAnywhere  |  Out-String
						write-host	
						write-host

				}
	
				if ($decision -eq "B")
				{
				
					# Section 1: Information 
					
					    write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                            
						write-host  -ForegroundColor white		Introduction                                                                                          
						write-host  -ForegroundColor white		--------------------------------------------------------------------------------------                                                              
						write-host  -ForegroundColor white  	'This option will: Display Outlook Anywhere setting for a specific Exchange CAS server '
						write-host  -ForegroundColor white		--------------------------------------------------------------------------------------    
						write-host  -ForegroundColor white  	'The PowerShell command syntax that we use is:  '
						write-host  -ForegroundColor white  	'Get-OutlookAnywhere Server <Server bname> '						
						write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
						write-host
						
						
						# Section 2: user input

								write-host
								write-host
								write-host -ForegroundColor Yellow	"1. Type the name of the Exchange server"  
								write-host -ForegroundColor Yellow	"For example: For example: ex02"
								write-host -ForegroundColor Yellow	"and Press The ENTER Key"
								write-host
								$EXSrvName = Read-Host "Type the name of the Exchange server "
								write-host
								write-host
								
						
						
						write-host	
						write-host	
						write-host		
						write-host ----------------------------------------------------------------------------------------------------
						write-host "$EXSrvName - Outlook AnyWhere settings"  -ForegroundColor white  -BackgroundColor DarkGreen    
						write-host ----------------------------------------------------------------------------------------------------
						write-host
						Get-OutlookAnywhere -Server $EXSrvName |  Out-String
						write-host	
						write-host
						
					# END of B Selection 
				
				}
				
				
				else
					{
					  Write-Host "Choose the required option by entering the letter of your choice"
					}


		Read-Host "Press Enter to continue..."
		write-host
		write-host


		}


#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#D: Manage Outlook Anywhere settings  | Exchange 2007\2010 server  
#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
		
	
		
		6
				{

					###############################################################################
					#Enable Outlook Anywhere on Exchange 2007\2010 server
					###############################################################################

					# Section 1: information 

						clear-host

					
					
					    write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                            
						write-host  -ForegroundColor white		Introduction                                                                                          
						write-host  -ForegroundColor white		--------------------------------------------------------------------------------------                                                              
						write-host  -ForegroundColor white  	'This option will: Enable Outlook Anywhere services on Exchange 2007\2010 CAS  '
						write-host  -ForegroundColor white  	'1. Set the value of the External Hostname '
						write-host  -ForegroundColor white  	'(The value will be added manually as part of the PowerShell command  ) '
						write-host  -ForegroundColor white  	'2.	Set the Default Authentication Method to: basic   '
						Write-host  -ForegroundColor white  	'(This value will be configured automatically by the PowerShell command)   '
						write-host  -ForegroundColor white  	'3.	Set the value of - SSL off-loading to: False  '
						Write-host  -ForegroundColor white  	'(This value will be configured automatically by the PowerShell command)   '
						write-host  -ForegroundColor white		--------------------------------------------------------------------------------------    
						write-host  -ForegroundColor white  	'The PowerShell command syntax that we use is:  '
						write-host  -ForegroundColor white  	'Enable-OutlookAnywhere -Server <Exchanege Server name>  -ExternalHostname <FQDN> -DefaultAuthenticationMethod <NTLM,Basic> -SSLOffloading $False '						
						write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
						write-host
						
						
						# Section 2: user input

								write-host
								write-host
								write-host -ForegroundColor Yellow	"1. Type the name of the Exchange server"  
								write-host -ForegroundColor Yellow	"For example: For example: ex02"
								write-host -ForegroundColor Yellow	"and Press The ENTER Key"
								write-host
								$EXSrvName = Read-Host "Type the name of the Exchange server "
								write-host
								write-host
								write-host -ForegroundColor Yellow	"2. Type the host name for the Outlook Anywhere service (RPC Endpoint) "  
								write-host -ForegroundColor Yellow	"For example: For example: mail.o365info.com"
								write-host -ForegroundColor Yellow	"and Press The ENTER Key"
								write-host
								$EXFQDN = Read-Host "Type the host name for the Outlook Anywhere service (RPC Endpoint) "
								write-host
								write-host
						
						
						# Section 3: Display results on screen (PowerShell Command)
					
								write-host "Enable Outlook Anywhere on $EXSrvName server" -ForegroundColor Yellow
								
								write-host
								# Phase 1 of 2 
								
								Enable-OutlookAnywhere -Server $EXSrvName -ExternalHostname $EXFQDN -DefaultAuthenticationMethod 'Basic' -SSLOffloading $False
								
								
								
								# Display information on the screen
								write-host -------------------------------------------------
								write-host "$EXSrvName - Outlook AnyWhere settings" -ForegroundColor Yellow
								write-host -------------------------------------------------

								write-host "Outlook AnyWhere settings" -ForegroundColor Yellow
								Get-OutlookAnywhere -Server $EXSrvName  |  Out-String
							
								
								# Phase 1 of 2 
								write-host "Set Outlook Anywhere settings on $EXSrvName server" -ForegroundColor Yellow
								
								write-host
								
								# Get-OutlookAnywhere Server $EXSrvName | Set-OutlookAnywhere -InternalHostname $EXFQDN -InternalClientAuthenticationMethod basic -InternalClientsRequireSsl $True -ExternalHostname $EXFQDN  -ExternalClientAuthenticationMethod Basic -ExternalClientsRequireSsl $True -IISAuthenticationMethods NTLM,Basic -ssloffloading:$False
	
								Set-OutlookAnywhere -Identity "$EXSrvName\Rpc (Default Web Site)" -ClientAuthenticationMethod Basic -IISAuthenticationMethods NTLM, Basic
	
		
		Read-Host "Press Enter to continue..."
		write-host
		write-host

}
		
		7
				{

					###############################################################################
					# Set Outlook Anywhere settings on Exchange 2007\2010 CAS server
					###############################################################################

					# Section 1: information 

						clear-host

						write-host
						write-host
						write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                            
						write-host  -ForegroundColor white		Introduction                                                                                          
						write-host  -ForegroundColor white		--------------------------------------------------------------------------------------                                                              
						write-host  -ForegroundColor white  	'This option will Enable us to set (configure) Outlook Anywhere services on Exchange 2007\2010 CAS  '
						write-host  -ForegroundColor white  	'The ExternalHostname value will be manually set by the user    '
						write-host  -ForegroundColor white  	'The reset of the Outlook Anywhere setting will be automatically set by the PowerShell command:    '
						write-host  -ForegroundColor white  	'1. Exchange client authentication method (protocol)  the value will be automatically set to:Basic  '
						write-host  -ForegroundColor white  	'2. IIS Authentication Method (CAS to CAS)  the value will be automatically set to: NTLM and Basic '
						write-host  -ForegroundColor white  	'3. SSL off-loading  the value will be automatically set to: False   '
						write-host  -ForegroundColor white  	'4. Requirement for SSL - the value will be automatically set to: True '
						
						write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
						write-host

								# Section 2: user input

								write-host
								write-host
								write-host -ForegroundColor Yellow	"1. Type the name of the Exchange server"  
								write-host -ForegroundColor Yellow	"For example: For example: ex02"
								write-host -ForegroundColor Yellow	"and Press The ENTER Key"
								write-host
								$EXSrvName = Read-Host "Type the name of the Exchange server "
								write-host
								write-host
								write-host
								write-host -ForegroundColor Yellow	"2. Type the FQDN name of the Exchange server"  
								write-host -ForegroundColor Yellow	"For example: For example: mail.o365info.com"
								write-host -ForegroundColor Yellow	"and Press The ENTER Key"
								write-host
								$EXFQDN = Read-Host "Type the FQDN name of the Exchange server "
								write-host
								
		
		#  Section 4#6 | Start Autodiscover Active Directory SCP  configurations
		write-host "Set Outlook Anywhere settings on $EXSrvName server" -ForegroundColor Yellow
		
		write-host
		
	  Get-OutlookAnywhere Server $EXSrvName | Set-OutlookAnywhere -InternalHostname $EXFQDN -InternalClientAuthenticationMethod basic -InternalClientsRequireSsl $True -ExternalHostname $EXFQDN  -ExternalClientAuthenticationMethod Basic -ExternalClientsRequireSsl $True -IISAuthenticationMethods NTLM,Basic -ssloffloading:$False
	
		# Display information on the screen
		
		write-host -------------------------------------------------
		write-host "$EXSrvName - Outlook AnyWhere settings" -ForegroundColor Yellow
		write-host -------------------------------------------------

		write-host "Outlook AnyWhere settings" -ForegroundColor Yellow
		Get-OutlookAnywhere -Server $EXSrvName  |  Out-String


		Read-Host "Press Enter to continue..."
		write-host
		write-host
	
		# END info
		
		Read-Host "Press Enter to continue..."
		write-host
		write-host

}
		
		

#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#D: Manage Outlook Anywhere settings  | Exchange 2013 server  
#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
				
		
		
		
				8
				{

					###############################################################################
					#set Outlook Anywhere settings Exchange 2013 server
					###############################################################################

					# Section 1: information 

						clear-host

						write-host
						write-host
						write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                            
						write-host  -ForegroundColor white		Introduction                                                                                          
						write-host  -ForegroundColor white		--------------------------------------------------------------------------------------                                                              
						write-host  -ForegroundColor white  	'This option will Enable us to set (configure ) Outlook Anywhere services on Exchange 2013 CAS  '
						write-host  -ForegroundColor white  	'The ExternalHostname will be manually set by the user    '
						write-host  -ForegroundColor white  	'The reset of the Outlook Anywhere setting will be automatically set by the PowerShell command:    '
						write-host  -ForegroundColor white  	'1. Exchange client authentication method (protocol)  the value will be automatically set to:Basic  '
						write-host  -ForegroundColor white  	'2. IIS Authentication Method (CAS to CAS)  the value will be automatically set to: NTLM and Basic '
						write-host  -ForegroundColor white  	'3. SSL off-loading  the value will be automatically set to: False   '
						write-host  -ForegroundColor white  	'4. Requirement for SSL - the value will be automatically set to: True '
						write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
						write-host

							
								# Section 0: decision 

				write-host  -ForegroundColor white		Choose the required option                                                                                          
				write-host  -ForegroundColor white		----------------------------------------------------------------------------    
				$decision = Read-Host "Choose the required option by entering the letter of your choice   
				 `n[A] Set (configure) Outlook Anywhere setting using a predefined authentication settings on - Exchange 2013 CAS server  
				 `n[B] Set (configure) Outlook Anywhere setting using a Manual settings on - Exchange 2013 CAS server 				
				 " 
				 
				 
				do
				{
					$verified = Validate-UserSelection -ErrorMessage "Please choose between A, B" -Selection $decision -AllowedAnswers "A,B"
					if(-not($verified))
					{
						$decision = Read-Host "Choose the required option by entering the letter of your choice:"
					}
				}
				while(-not($verified))
	 
				
				if ($decision -eq "A")
				{
				
					# Section 1: Information 
					
					    write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                            
						write-host  -ForegroundColor white		Introduction                                                                                          
						write-host  -ForegroundColor white		--------------------------------------------------------------------------------------                                                              
						write-host  -ForegroundColor white  	'The following command use for setting the authentication setting of Exchange CAS 2013 in the following way:   '
						write-host  -ForegroundColor white  	'1. Exchange client authentication method (protocol)  the value will be automatically set to:Basic  '
						write-host  -ForegroundColor white  	'2. IIS Authentication Method (CAS to CAS)  the value will be automatically set to: NTLM and Basic '
						write-host  -ForegroundColor white  	'3. SSL off-loading  the value will be automatically set to: False   '
						write-host  -ForegroundColor white  	'4. Requirement for SSL - the value will be automatically set to: True '
						write-host  -ForegroundColor white		--------------------------------------------------------------------------------------    
						write-host  -ForegroundColor white  	'The PowerShell command syntax that we use is:  '
						write-host  -ForegroundColor white  	'The PowerShell command syntax that we use is:  '
						write-host  -ForegroundColor white  	'Get-OutlookAnywhere Server <Exchange 2013 CAS server>| Set-OutlookAnywhere -InternalHostname <Domain name> -InternalClientAuthenticationMethod NTLM  -InternalClientsRequireSsl $true -ExternalHostname <Domain name> 
																	-ExternalClientAuthenticationMethod Basic -ExternalClientsRequireSsl $true 
																	-IISAuthenticationMethods NTLM,Basic -ssloffloading:$False
																	 '											
						write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
						write-host
						
						
						# Section 2: user input

								write-host
								write-host
								write-host -ForegroundColor Yellow	"1. Type the name of the Exchange 2013 CAS server"  
								write-host -ForegroundColor Yellow	"For example: For example: ex02"
								write-host -ForegroundColor Yellow	"and Press The ENTER Key"
								write-host
								$EXSrvName = Read-Host "Type the name of the Exchange 2013 CAS server "
								write-host
								write-host
								write-host -ForegroundColor Yellow	"2. Type the host name for the Outlook Anywhere service (RPC Endpoint) "  
								write-host -ForegroundColor Yellow	"For example: For example: mail.o365info.com"
								write-host -ForegroundColor Yellow	"and Press The ENTER Key"
								write-host
								$EXFQDN = Read-Host "Type the host name for the Outlook Anywhere service (RPC Endpoint) "
								write-host
								write-host
						
						
						# Section 3: Display results on screen (PowerShell Command)
					
								write-host "Set Outlook Anywhere settings on $EXSrvName 2013 CAS server" -ForegroundColor Yellow
								
								write-host
								
								 Get-OutlookAnywhere Server $EXSrvName| Set-OutlookAnywhere -InternalHostname $EXFQDN -InternalClientAuthenticationMethod basic -InternalClientsRequireSsl $True -ExternalHostname $EXFQDN -ExternalClientAuthenticationMethod Basic -ExternalClientsRequireSsl $true -IISAuthenticationMethods NTLM,Basic -ssloffloading:$false
								
								
								
								# Display information on the screen
								
								write-host -------------------------------------------------
								write-host "$EXSrvName - Outlook AnyWhere settings" -ForegroundColor Yellow
								write-host -------------------------------------------------

								write-host "Outlook AnyWhere settings" -ForegroundColor Yellow
								Get-OutlookAnywhere -Server $EXSrvName  |  Out-String
							
					
	
				}
	
				if ($decision -eq "B")
				{
				
					# Section 1: Information 
					
					    write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                            
						write-host  -ForegroundColor white		Introduction                                                                                          
						write-host  -ForegroundColor white		--------------------------------------------------------------------------------------                                                              
						write-host  -ForegroundColor white  	'This option will: Set Outlook Anywhere settings on Exchange 2007\2010 CAS  '
						write-host  -ForegroundColor white  	'This settings will be applied to Exchange CAS server internal and external Outlook Anywhere interfaces  '
						write-host  -ForegroundColor white  	'1. Set the value of the external Hostname '
						write-host  -ForegroundColor white  	'2.	Set the client authentication method of internal and external clients to: basic   '
						write-host  -ForegroundColor white  	'3.	Set the IIS Authentication Method to: Basic + NTLM  '
						write-host  -ForegroundColor white  	'4.	Set the value of - SSL off-loading to: False  '
						write-host  -ForegroundColor white  	'5.	Set the requirement for SSL of internal and external clients to: True '
						write-host  -ForegroundColor white		--------------------------------------------------------------------------------------    
						write-host  -ForegroundColor white  	'The PowerShell command syntax that we use is:  '
						write-host  -ForegroundColor white  	'Enable-OutlookAnywhere -Server <Exchanege Server name>  -ExternalHostname <FQDN> -DefaultAuthenticationMethod 'Basic' -SSLOffloading $false '						
						write-host  -ForegroundColor Magenta	oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo                                          
						write-host
						
						
						# Section 2: user input

								write-host You will need to provide six parameters
								write-host  -ForegroundColor white		--------------------------------------------------------------------------------------  								
								write-host
								write-host -ForegroundColor Yellow	"1. Type the name of the Exchange server"  
								write-host -ForegroundColor Yellow	"For example: For example: ex02"
								write-host -ForegroundColor Yellow	"and Press The ENTER Key"
								write-host
								$EXSrvName = Read-Host "Type the name of the Exchange server "
								write-host
								write-host
								write-host -ForegroundColor Yellow	"2. Provide the host name for the Outlook Anywhere service (RPC Endpoint) - EXTERNAL NAME "  
								write-host -ForegroundColor Yellow	"For example: For example: mail.o365info.com"
								write-host -ForegroundColor Yellow	"and Press The ENTER Key"
								write-host
								$EXFQDN1 = Read-Host "Provide the host name for the Outlook Anywhere service (RPC Endpoint) - EXTERNAL NAME "
								write-host
								write-host
								write-host -ForegroundColor Yellow	"3. Provide the host name for the Outlook Anywhere service (RPC Endpoint) - INTERNAL NAME"  
								write-host -ForegroundColor Yellow	"For example: For example: SRV1.o365info.com"
								write-host -ForegroundColor Yellow	"and Press The ENTER Key"
								write-host
								$EXFQDN2 = Read-Host "Provide the host name for the Outlook Anywhere service (RPC Endpoint) - INTERNAL NAME "
								write-host
								write-host
								write-host
								write-host -ForegroundColor Yellow	"4. Type the client authentication method - internal client"  
								write-host -ForegroundColor Yellow	"For example: For example: Basic"
								write-host -ForegroundColor Yellow	"and Press The ENTER Key"
								write-host
								$AuthINT = Read-Host "Type the client authentication method - internal client "
								write-host
								write-host
								write-host
								write-host -ForegroundColor Yellow	"5. Type the client authentication method - External client"  
								write-host -ForegroundColor Yellow	"For example: For example: Basic"
								write-host -ForegroundColor Yellow	"and Press The ENTER Key"
								write-host
								$AuthEXT = Read-Host "Type the client authentication method - External client "
								write-host
								write-host
								write-host -ForegroundColor Yellow	"6. Type the IIS Authentication Method "  
								write-host -ForegroundColor Yellow	"For example: For example: Basic"
								write-host -ForegroundColor Yellow	"and Press The ENTER Key"
								write-host
								$AuthIIS = Read-Host "Type the IIS Authentication Method "
								write-host
								write-host
						
						
						# Section 3: Display results on screen (PowerShell Command)
					
								write-host "Set the internal + external host name on $EXSrvName server" -ForegroundColor Yellow
								
								write-host
								
								Get-OutlookAnywhere Server $EXSrvName | Set-OutlookAnywhere -InternalHostname $EXFQDN2 -ExternalHostname $EXFQDN1 -ExternalClientsRequireSsl $true 
								
								
								
								# Display information on the screen
								
								write-host -------------------------------------------------
								write-host "$EXSrvName - Outlook AnyWhere settings" -ForegroundColor Yellow
								write-host -------------------------------------------------

								write-host "Outlook AnyWhere settings" -ForegroundColor Yellow
								Get-OutlookAnywhere -Server $EXSrvName  |  Out-String
						
					# END of B Selection 
				
				}
				
				
				else
					{
					  Write-Host "Choose the required option by entering the letter of your choice"
					}

				
		
	

		Read-Host "Press Enter to continue..."
		write-host
		write-host
	
		# END info
		
		Read-Host "Press Enter to continue..."
		write-host
		write-host
}
		
		
		
		
		
		
		

		
 
			 
			#+++++++++++++++++++
			# Step -05 Finish  
			##++++++++++++++++++
 
			 
			11{

			##########################################
			# Disconnect PowerShell session  
			##########################################


			write-host -ForegroundColor Yellow Choosing this option will Disconnect the current PowerShell session 

			Disconnect-ExchangeOnline 

			write-host
			write-host

			# Indication 

		if ($lastexitcode -eq 0)
		{
			write-host -------------------------------------------------------------
			write-host "The command complete successfully !" -ForegroundColor Yellow
			write-host "The PowerShell session is disconnected" -ForegroundColor Yellow
			write-host -------------------------------------------------------------
		}
		else

		{
			write-host "The command Failed :-(" -ForegroundColor red
			
		}

		# End of Indication 


		}




		12
		{

		##########################################
		# Exit  
		##########################################


		$Loop = $true
		Exit
		}

		}


		}
